
/*  A Bison parser, made from SelectParser.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	PLUS	257
#define	MINUS	258
#define	MULT	259
#define	DIV	260
#define	EXPO	261
#define	MODULO	262
#define	ANDIF	263
#define	ORIF	264
#define	NOT	265
#define	GTI	266
#define	MASK	267
#define	REGION	268
#define	IN	269
#define	AND	270
#define	OR	271
#define	XOR	272
#define	LSHIFT	273
#define	RSHIFT	274
#define	BITCOMPL	275
#define	TRUECONST	276
#define	FALSECONST	277
#define	POLYGONFUNC	278
#define	POLYGONFUNC2	279
#define	LT	280
#define	LE	281
#define	GT	282
#define	GE	283
#define	EQ	284
#define	NE	285
#define	AFUNC	286
#define	AFUNC2	287
#define	SFUNC	288
#define	ASFUNC	289
#define	SPATFUNC4	290
#define	SPATFUNC5	291
#define	SPATFUNC6	292
#define	SPATFUNC7	293
#define	SPATFUNC10	294
#define	NEAR	295
#define	IFTHENELSE	296
#define	BIDENT	297
#define	IIDENT	298
#define	RIDENT	299
#define	SIDENT	300
#define	NLITERAL	301
#define	SLITERAL	302
#define	ISNULL	303
#define	SELECTED	304
#define	FILENAME	305

#line 1 "SelectParser.y"

//---------------------------------------------------------------------------
//
//                     XMM Science Analysis System (SAS)
//                   (c) 1997-2010 European Space Agency
//
//---------------------------------------------------------------------------
//
//	SelectParser.y --- grammar for selection library
//
//	DESCRIPTION:
//		This is a yacc/bison input file which defines the grammar of
//		boolean expressions to be used by the event selection tasks in the SAS
//
//	CHANGE HISTORY:
//		UL, 1997-12-17: 1.0.0: - first version
//		UL, 1998-04-06: 1.1.0: - various new features addded
//		UL, 1998-04-09: 1.2.0: - ifthenelse added
//		UL, 1998-05-19: 2.0.0: - made it more C++'ish
//							   - have no a start symbol which reduces to
//								 either a logic or arithmetic expression
//		UL, 1998-06-18: 2.1.0: - added 'IN' operator for
//									o intervals, e.g. "PHA in 0.1,10"
//									o regions, e.g. (10,10) in circle(10,10,3)
//									o file-based filters, e.g.,
//										"10.1 in gti(gti.fits)"
//							   - for the file-based filters, blocks can now
//								 be specified by name as well as number, e.g.
//									gti.fits[GTI10]  or   gti.fits[12]
//							   - new boolean function "SELECTED"; gets
//								 expanded into conventional constructs in the
//								 lexer
//		UL, 1999-11-17: 2.2.0: - updates to avoid name clashes at the linking
//								 stage with more than one lexer/parser in the
//								 system:
//									o call the lexer with a special name
//									o wrap the parser in a namespace
//		UL, 2000-05-29: 2.3.0: - fixed bug in mask filter which caused
//									mask(m.ds, xOff, yOff, xCol, yCol)
//								 and
//									(xCol, yCol) in mask(m.ds, xOff, yOff)
//								 to behave differently
//		UL, 2000-07-03: 2.4.0: - several changes related to support of
//								 string columns / null values
//
//	AUTHOR:
//		U. Lammers (UL), Dec 17 11:48:12 MET DST 1997
//
//	$Header: /usr/local/cvs/sasdev/sas/packages/selectlib/src/selcore/SelectParser.cc,v 1.6 2002/03/18 18:14:42 ulammers Exp $
///

#include <string>

#include "basicdefs.h"
#include "Selector.h"
#include "NumericFunctors.h"
#include "RegionFilter.h"
#include "StringFunctors.h"
#include "SelectBlockFuncs.h"

SelectorGlobals selectorGlobalsInstance = {
		0,		//	pointer to symbol table
		0,		//	expression tree
		true,	//	tree can be evaluated in logical context
		0,		//	table descriptor
		0		//	evaluator
};
SelectorGlobals *selectorGlobals = &selectorGlobalsInstance;

static void prependSetName(std::string *s)
{
	if ((*s)[0] == '[' || (*s)[0] == '+')
		s->insert(0, selectorGlobals->tableDescriptor ?
						selectorGlobals->tableDescriptor->setName() : "");
}

#define yylex		selectlex
extern int selectlex();			//	this is the name of the lexer function
								//	that flex generates with the -Pselect
								//	option; we do need a distinct name
								//	in order to avoid name clashes with
								//	other lexers in the SAS

namespace SelectParser {

extern void yyerror(char *);	//	The locally added functions in the
								//	lexer are in a namespace SelectParser


#line 91 "SelectParser.y"
typedef union {
	OpNode		yNode;
	std::string	*yFileName;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		389
#define	YYFLAG		-32768
#define	YYNTBASE	58

#define YYTRANSLATE(x) ((unsigned)(x) <= 305 ? yytranslate[x] : 66)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    52,
    53,     2,     2,    54,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    56,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    55,     2,    57,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     6,     8,    10,    14,    18,    21,    25,
    29,    33,    37,    41,    45,    49,    53,    57,    61,    65,
    69,    73,    77,    81,    85,    89,    93,    97,   106,   115,
   126,   139,   152,   167,   182,   199,   216,   235,   258,   283,
   292,   303,   312,   323,   330,   337,   346,   351,   362,   375,
   390,   394,   399,   404,   406,   410,   414,   418,   422,   426,
   430,   434,   438,   442,   446,   450,   453,   458,   465,   468,
   473,   477,   479,   481,   483,   487,   492,   497,   503,   508,
   511,   515,   519,   521,   523,   529,   533,   537,   539,   541,
   545,   549,   553,   557,   559,   563,   566,   571,   576,   581,
   586,   589,   594,   599,   604,   609,   613,   619,   625,   631
};

static const short yyrhs[] = {    59,
     0,    60,     0,    22,     0,    23,     0,    50,     0,    59,
    10,    59,     0,    59,     9,    59,     0,    11,    59,     0,
    60,    30,    60,     0,    60,    30,    59,     0,    59,    30,
    60,     0,    59,    30,    59,     0,    60,    31,    60,     0,
    60,    31,    59,     0,    59,    31,    60,     0,    59,    31,
    59,     0,    60,    26,    60,     0,    60,    27,    60,     0,
    60,    28,    60,     0,    60,    29,    60,     0,    52,    59,
    53,     0,    62,    30,    62,     0,    62,    31,    62,     0,
    62,    26,    62,     0,    62,    27,    62,     0,    62,    28,
    62,     0,    62,    29,    62,     0,    41,    52,    60,    54,
    60,    54,    60,    53,     0,    42,    52,    59,    54,    59,
    54,    59,    53,     0,    36,    52,    60,    54,    60,    54,
    60,    54,    60,    53,     0,    52,    60,    54,    60,    53,
    15,    36,    52,    60,    54,    60,    53,     0,    37,    52,
    60,    54,    60,    54,    60,    54,    60,    54,    60,    53,
     0,    52,    60,    54,    60,    53,    15,    37,    52,    60,
    54,    60,    54,    60,    53,     0,    38,    52,    60,    54,
    60,    54,    60,    54,    60,    54,    60,    54,    60,    53,
     0,    52,    60,    54,    60,    53,    15,    38,    52,    60,
    54,    60,    54,    60,    54,    60,    53,     0,    39,    52,
    60,    54,    60,    54,    60,    54,    60,    54,    60,    54,
    60,    54,    60,    53,     0,    52,    60,    54,    60,    53,
    15,    39,    52,    60,    54,    60,    54,    60,    54,    60,
    54,    60,    53,     0,    40,    52,    60,    54,    60,    54,
    60,    54,    60,    54,    60,    54,    60,    54,    60,    54,
    60,    54,    60,    54,    60,    53,     0,    52,    60,    54,
    60,    53,    15,    40,    52,    60,    54,    60,    54,    60,
    54,    60,    54,    60,    54,    60,    54,    60,    54,    60,
    53,     0,    24,    52,    63,    54,    60,    54,    60,    53,
     0,    52,    60,    54,    60,    53,    15,    24,    52,    63,
    53,     0,    25,    52,    63,    54,    60,    54,    60,    53,
     0,    52,    60,    54,    60,    53,    15,    25,    52,    63,
    53,     0,    12,    52,    51,    54,    60,    53,     0,    60,
    15,    12,    52,    51,    53,     0,    14,    52,    51,    54,
    60,    54,    60,    53,     0,    14,    52,    51,    53,     0,
    52,    60,    54,    60,    53,    15,    14,    52,    51,    53,
     0,    13,    52,    51,    54,    60,    54,    60,    54,    60,
    54,    60,    53,     0,    52,    60,    54,    60,    53,    15,
    13,    52,    51,    54,    60,    54,    60,    53,     0,    60,
    15,    64,     0,    49,    52,    44,    53,     0,    49,    52,
    45,    53,     0,    43,     0,    60,     3,    60,     0,    60,
     4,    60,     0,    60,     5,    60,     0,    60,     6,    60,
     0,    60,     8,    60,     0,    60,     7,    60,     0,    60,
    16,    60,     0,    60,    17,    60,     0,    60,    18,    60,
     0,    60,    19,    60,     0,    60,    20,    60,     0,    21,
    60,     0,    32,    52,    60,    53,     0,    33,    52,    60,
    54,    60,    53,     0,     4,    60,     0,    35,    52,    62,
    53,     0,    52,    60,    53,     0,    47,     0,    44,     0,
    45,     0,    55,    56,    57,     0,    55,    60,    56,    57,
     0,    55,    56,    60,    57,     0,    55,    60,    56,    60,
    57,     0,    34,    52,    62,    53,     0,    62,    61,     0,
    62,     3,    62,     0,    52,    62,    53,     0,    48,     0,
    46,     0,    63,    54,    60,    54,    60,     0,    60,    54,
    60,     0,    64,    54,    65,     0,    65,     0,    56,     0,
    55,    56,    57,     0,    52,    56,    57,     0,    55,    56,
    53,     0,    52,    56,    53,     0,    60,     0,    55,    60,
    57,     0,    60,    56,     0,    55,    60,    56,    57,     0,
    55,    60,    56,    53,     0,    52,    60,    56,    57,     0,
    52,    60,    56,    53,     0,    56,    60,     0,    55,    56,
    60,    57,     0,    55,    56,    60,    53,     0,    52,    56,
    60,    57,     0,    52,    56,    60,    53,     0,    60,    56,
    60,     0,    55,    60,    56,    60,    57,     0,    52,    60,
    56,    60,    57,     0,    55,    60,    56,    60,    53,     0,
    52,    60,    56,    60,    53,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   129,   131,   134,   135,   136,   137,   138,   139,   140,   141,
   142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
   152,   153,   154,   155,   156,   157,   158,   159,   163,   167,
   171,   175,   179,   184,   189,   194,   199,   205,   211,   218,
   221,   224,   228,   232,   236,   240,   244,   248,   252,   256,
   260,   263,   272,   273,   275,   276,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   287,   290,   294,   295,
   298,   299,   300,   301,   303,   304,   305,   306,   308,   312,
   317,   320,   321,   322,   324,   327,   330,   334,   338,   339,
   340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
   350,   351,   352,   353,   354,   355,   356,   357,   358,   359
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","PLUS","MINUS",
"MULT","DIV","EXPO","MODULO","ANDIF","ORIF","NOT","GTI","MASK","REGION","IN",
"AND","OR","XOR","LSHIFT","RSHIFT","BITCOMPL","TRUECONST","FALSECONST","POLYGONFUNC",
"POLYGONFUNC2","LT","LE","GT","GE","EQ","NE","AFUNC","AFUNC2","SFUNC","ASFUNC",
"SPATFUNC4","SPATFUNC5","SPATFUNC6","SPATFUNC7","SPATFUNC10","NEAR","IFTHENELSE",
"BIDENT","IIDENT","RIDENT","SIDENT","NLITERAL","SLITERAL","ISNULL","SELECTED",
"FILENAME","'('","')'","','","'['","':'","']'","expr","logic","arith","textrange",
"text","pointlist","intervallist","intervalspec", NULL
};
#endif

static const short yyr1[] = {     0,
    58,    58,    59,    59,    59,    59,    59,    59,    59,    59,
    59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
    59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
    59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
    59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
    59,    59,    59,    59,    60,    60,    60,    60,    60,    60,
    60,    60,    60,    60,    60,    60,    60,    60,    60,    60,
    60,    60,    60,    60,    61,    61,    61,    61,    62,    62,
    62,    62,    62,    62,    63,    63,    64,    64,    65,    65,
    65,    65,    65,    65,    65,    65,    65,    65,    65,    65,
    65,    65,    65,    65,    65,    65,    65,    65,    65,    65
};

static const short yyr2[] = {     0,
     1,     1,     1,     1,     1,     3,     3,     2,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     8,     8,    10,
    12,    12,    14,    14,    16,    16,    18,    22,    24,     8,
    10,     8,    10,     6,     6,     8,     4,    10,    12,    14,
     3,     4,     4,     1,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     2,     4,     6,     2,     4,
     3,     1,     1,     1,     3,     4,     4,     5,     4,     2,
     3,     3,     1,     1,     5,     3,     3,     1,     1,     3,
     3,     3,     3,     1,     3,     2,     4,     4,     4,     4,
     2,     4,     4,     4,     4,     3,     5,     5,     5,     5
};

static const short yydefact[] = {     0,
     0,     0,     0,     0,     0,     0,     3,     4,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    54,    73,    74,    84,    72,    83,     0,     5,     0,
     1,     2,     0,     0,    69,     8,     0,     0,     0,     0,
    66,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    80,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    21,    71,     0,    82,     7,     6,    12,    11,    16,    15,
    55,    56,    57,    58,    60,    59,     0,     0,     0,    89,
    94,    51,    88,    61,    62,    63,    64,    65,    17,    18,
    19,    20,    10,     9,    14,    13,    81,    24,    25,    26,
    27,    22,    23,     0,     0,     0,     0,    47,     0,     0,
     0,     0,    67,     0,     0,    79,    70,     0,     0,     0,
     0,     0,     0,     0,    52,    53,     0,     0,     0,     0,
     0,     0,   101,    96,     0,    75,     0,     0,     0,     0,
     0,    86,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    93,    91,     0,     0,    92,    90,
     0,     0,    95,   106,    87,    77,    76,     0,    44,     0,
     0,     0,     0,    68,     0,     0,     0,     0,     0,     0,
     0,     0,    45,   105,   104,   100,    99,     0,   103,   102,
    98,    97,     0,    78,     0,     0,    85,    85,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   110,   108,   109,   107,     0,    46,
    40,    42,     0,     0,     0,     0,     0,    28,    29,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    30,     0,     0,     0,     0,     0,
    48,    41,     0,    43,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    49,    32,     0,     0,     0,     0,     0,    31,     0,
     0,     0,     0,     0,     0,     0,     0,    85,     0,     0,
     0,     0,    34,     0,     0,    50,    33,     0,     0,     0,
     0,     0,     0,     0,     0,    36,     0,    35,     0,     0,
     0,     0,     0,     0,    37,     0,     0,     0,     0,     0,
     0,     0,    38,     0,     0,    39,     0,     0,     0
};

static const short yydefgoto[] = {   387,
    31,    37,    89,    33,    95,   132,   133
};

static const short yypact[] = {  2260,
  2307,  2260,   -49,   -47,   -39,  2307,-32768,-32768,   -35,   -31,
   -19,   -16,    -6,    48,    67,    72,    73,    75,    79,    87,
    88,-32768,-32768,-32768,-32768,-32768,-32768,    92,-32768,  2260,
    -2,  2317,    28,  2307,-32768,-32768,  2317,   -24,    31,    45,
-32768,  2307,  2307,  2307,  2307,   -30,   -30,  2307,  2307,  2307,
  2307,  2307,  2307,  2260,   -25,   187,   706,   648,  2260,  2260,
  2260,  2260,  2307,  2307,  2307,  2307,  2307,  2307,   582,  2307,
  2307,  2307,  2307,  2307,  2307,  2307,  2307,  2307,  2260,  2260,
   -30,   -30,   -30,   -30,   -30,   -30,   -30,   614,-32768,  1840,
    93,    94,    41,   494,    95,    99,  1869,   735,   -30,    32,
    90,   758,   764,   787,   816,   839,   845,   111,   105,   113,
-32768,-32768,  2307,-32768,    -7,    77,-32768,  2357,-32768,  2357,
     4,     4,   145,   145,-32768,   145,   115,   636,   652,  2307,
   447,   126,-32768,   325,  1927,   794,   228,   228,  2384,  2384,
  2384,  2384,-32768,  2357,-32768,  2357,   127,    44,    44,    44,
    44,    44,    44,   548,   453,  2307,  2307,-32768,  2307,  2307,
  2307,  2307,-32768,  2307,   123,-32768,-32768,  2307,  2307,  2307,
  2307,  2307,  2307,  2260,-32768,-32768,  1891,   132,   142,   429,
   472,   240,  2384,  2307,   598,-32768,   405,   552,  1897,   868,
   897,  2384,   920,   926,  1920,   949,   978,  1001,  1007,  1030,
  1059,   183,   175,   138,-32768,-32768,    98,   502,-32768,-32768,
   246,   518,-32768,  2384,-32768,-32768,-32768,   411,-32768,  2307,
  2307,  2307,  2307,-32768,  2307,  2307,  2307,  2307,  2307,  2307,
  2260,     1,-32768,-32768,-32768,-32768,-32768,   345,-32768,-32768,
-32768,-32768,   387,-32768,  1082,  1948,  1971,  1977,  1088,  1111,
  1140,  1163,  1169,  1999,   261,   146,   148,   149,   150,   151,
   153,   154,   155,   157,-32768,-32768,-32768,-32768,  2307,-32768,
-32768,-32768,  2307,  2307,  2307,  2307,  2307,-32768,-32768,   159,
   160,  2307,  2307,  2307,  2307,  2307,  2307,  2307,  1192,  2028,
  1221,  1244,  1250,  1273,   161,   163,    58,    69,  1302,  1325,
  1331,  1354,  1383,  2307,-32768,  2307,  2307,  2307,  2307,  2307,
-32768,-32768,  2307,-32768,  2307,  2307,  2307,  2307,  2307,  2050,
  2056,  1406,  1412,  1435,  1464,  1487,  2079,  1493,  1516,  1545,
  1568,-32768,-32768,  2307,  2307,  2307,  2307,  2307,-32768,  2307,
  2307,  2307,  2307,  2107,  1574,  1597,  2130,  2384,  2136,  1626,
  1649,  1655,-32768,  2307,  2307,-32768,-32768,  2307,  2307,  2307,
  2158,  1678,  2187,  1707,  1730,-32768,  2307,-32768,  2307,  2307,
  1736,  2209,  1759,  2307,-32768,  2307,  1788,  1811,  2307,  2307,
  2215,  1817,-32768,  2307,  2238,-32768,   219,   224,-32768
};

static const short yypgoto[] = {-32768,
    30,     0,-32768,    51,   -41,-32768,    53
};


#define	YYLAST		2404


static const short yytable[] = {    32,
    35,    96,    38,    13,    39,    41,    59,    60,    65,    66,
    67,    68,    40,   256,   257,    25,    42,    27,   109,   110,
    43,    99,    61,    62,   258,   259,    91,    61,    62,    57,
    81,    36,    44,    90,    81,    45,   260,   261,   262,   263,
   264,    94,    94,    97,    98,    46,    81,   102,   103,   104,
   105,   106,   107,    82,    83,    84,    85,    86,    87,    56,
   118,   120,   121,   122,   123,   124,   125,   126,   131,   134,
   135,   136,   137,   138,   139,   140,   141,   142,   144,   146,
    58,    92,    88,   108,   166,    59,    88,   155,   115,   116,
   117,   119,    81,   158,   159,    93,   100,   101,    88,    47,
    63,    64,    65,    66,    67,    68,    61,    62,   143,   145,
   312,   313,   177,    70,    71,    72,    73,    74,    48,    59,
    60,   314,   313,    49,    50,    81,    51,   180,   182,   183,
    52,   147,   148,   149,   150,   151,   152,   153,    53,    54,
    61,    62,   167,    55,    88,     1,   156,   157,   161,   165,
   234,    67,   162,   187,   235,   189,   190,   175,   191,   192,
   193,   194,     6,   195,   174,   176,   178,   196,   197,   198,
   199,   200,   201,    11,    12,   114,    14,    88,   207,   185,
   211,    88,   204,   214,   131,    23,    24,   218,    26,   232,
   233,    59,    60,    34,   205,    59,    60,   280,   206,   281,
   282,   283,   284,   202,   285,   286,   287,   238,   288,   295,
   296,   243,    61,    62,   310,   311,    61,    62,   388,   245,
   246,   247,   248,   389,   249,   250,   251,   252,   253,   254,
    63,    64,    65,    66,    67,    68,   231,   215,     0,   111,
   297,   298,    63,    64,    65,    66,    67,    68,    63,    64,
    65,    66,    67,    68,     0,    70,    71,    72,    73,    74,
   255,    70,    71,    72,    73,    74,     0,     0,   289,    59,
    60,     0,   290,   291,   292,   293,   294,     0,     0,     0,
     0,    94,    94,   299,   300,   301,   302,   303,     0,     0,
    61,    62,     0,     0,     0,   212,   213,     0,   239,     0,
     0,     0,   240,   320,     0,   321,   322,   323,   324,   325,
     0,     0,   326,   279,   327,   328,   329,   330,   331,     0,
     0,     0,     0,     0,     0,     0,     0,    63,    64,    65,
    66,    67,    68,   344,   345,   346,   347,   348,     0,   349,
   350,   351,   352,    73,    74,     0,     0,    63,    64,    65,
    66,    67,    68,   361,   362,     0,     0,   363,   364,   365,
    70,    71,    72,    73,    74,     0,   371,     0,   372,   373,
     0,     0,     0,   377,     0,   378,     0,     0,   381,   382,
     0,     0,     0,   385,     0,     0,     0,     0,     0,    63,
    64,    65,    66,    67,    68,     0,     0,   265,     0,     0,
     0,   266,    70,    71,    72,    73,    74,    63,    64,    65,
    66,    67,    68,    63,    64,    65,    66,    67,    68,     0,
    70,    71,    72,    73,    74,     0,    70,    71,    72,    73,
    74,    63,    64,    65,    66,    67,    68,     0,     0,   267,
     0,     0,     0,   268,    70,    71,    72,    73,    74,    63,
    64,    65,    66,    67,    68,    63,    64,    65,    66,    67,
    68,   216,    70,    71,    72,    73,    74,   244,    70,    71,
    72,    73,    74,     0,     0,     1,     0,     0,     0,     0,
     0,   112,     0,     0,   208,     0,     0,     0,     0,     0,
     0,     0,     6,     0,     0,     0,    63,    64,    65,    66,
    67,    68,   184,    11,    12,     1,    14,     0,   188,    70,
    71,    72,    73,    74,     0,    23,    24,     0,    26,     0,
     0,     1,     6,    34,   209,     0,     0,     0,   210,     0,
     0,     0,     0,    11,    12,     0,    14,     0,     6,     0,
     0,     0,     0,     0,     0,    23,    24,   160,    26,    11,
    12,     1,    14,    34,   236,     1,     0,     0,   237,     0,
     0,    23,    24,     0,    26,     0,     0,     0,     6,    34,
   241,     0,     6,     0,   242,     0,     0,     0,     0,    11,
    12,     0,    14,    11,    12,     1,    14,     0,     0,     0,
     0,    23,    24,   127,    26,    23,    24,     0,    26,    34,
     0,     1,     6,    34,   186,     0,     0,     0,   217,     0,
     0,     0,     0,    11,    12,     0,    14,     1,     6,     0,
     0,     0,     0,     0,     0,    23,    24,     0,    26,    11,
    12,     0,    14,   128,     6,     0,   129,   130,     0,     1,
     0,    23,    24,     0,    26,    11,    12,     0,    14,   128,
    81,     0,   129,   130,     0,     1,     6,    23,    24,     0,
    26,     0,     0,     0,     0,    34,     0,    11,    12,   154,
    14,     0,     6,    82,    83,    84,    85,    86,    87,    23,
    24,     0,    26,    11,    12,     0,    14,    34,     0,     0,
     0,   179,     0,     0,     0,    23,    24,     0,    26,     0,
   114,     0,    88,    34,     0,     0,     0,   181,    63,    64,
    65,    66,    67,    68,     0,     0,     0,     0,     0,     0,
    69,    70,    71,    72,    73,    74,     0,     0,     0,     0,
     0,    75,    76,    77,    78,    79,    80,    63,    64,    65,
    66,    67,    68,     0,     0,     0,     0,     0,     0,     0,
    70,    71,    72,    73,    74,     0,     0,     0,   112,   113,
    63,    64,    65,    66,    67,    68,    63,    64,    65,    66,
    67,    68,     0,    70,    71,    72,    73,    74,     0,    70,
    71,    72,    73,    74,     0,     0,     0,     0,   164,    63,
    64,    65,    66,    67,    68,     0,    63,    64,    65,    66,
    67,    68,    70,    71,    72,    73,    74,     0,     0,    70,
     0,   168,    73,    74,     0,     0,     0,   169,    63,    64,
    65,    66,    67,    68,     0,     0,     0,     0,     0,     0,
     0,    70,    71,    72,    73,    74,     0,     0,     0,     0,
   170,    63,    64,    65,    66,    67,    68,    63,    64,    65,
    66,    67,    68,     0,    70,    71,    72,    73,    74,     0,
    70,    71,    72,    73,    74,     0,     0,     0,     0,   171,
    63,    64,    65,    66,    67,    68,     0,     0,     0,     0,
     0,     0,     0,    70,    71,    72,    73,    74,     0,     0,
     0,     0,   172,     0,     0,     0,     0,     0,   173,    63,
    64,    65,    66,    67,    68,     0,     0,     0,     0,     0,
     0,     0,    70,    71,    72,    73,    74,     0,     0,     0,
     0,   220,    63,    64,    65,    66,    67,    68,    63,    64,
    65,    66,    67,    68,     0,    70,    71,    72,    73,    74,
     0,    70,    71,    72,    73,    74,     0,     0,     0,     0,
   221,    63,    64,    65,    66,    67,    68,     0,     0,     0,
     0,     0,     0,     0,    70,    71,    72,    73,    74,     0,
     0,     0,     0,   222,     0,     0,     0,     0,     0,   223,
    63,    64,    65,    66,    67,    68,     0,     0,     0,     0,
     0,     0,     0,    70,    71,    72,    73,    74,     0,     0,
     0,     0,   225,    63,    64,    65,    66,    67,    68,    63,
    64,    65,    66,    67,    68,     0,    70,    71,    72,    73,
    74,     0,    70,    71,    72,    73,    74,     0,     0,     0,
     0,   226,    63,    64,    65,    66,    67,    68,     0,     0,
     0,     0,     0,     0,     0,    70,    71,    72,    73,    74,
     0,     0,     0,     0,   227,     0,     0,     0,     0,     0,
   228,    63,    64,    65,    66,    67,    68,     0,     0,     0,
     0,     0,     0,     0,    70,    71,    72,    73,    74,     0,
     0,     0,     0,   229,    63,    64,    65,    66,    67,    68,
    63,    64,    65,    66,    67,    68,     0,    70,    71,    72,
    73,    74,     0,    70,    71,    72,    73,    74,     0,     0,
     0,     0,   230,    63,    64,    65,    66,    67,    68,     0,
     0,     0,     0,     0,     0,     0,    70,    71,    72,    73,
    74,     0,     0,     0,     0,   269,     0,     0,     0,     0,
     0,   273,    63,    64,    65,    66,    67,    68,     0,     0,
     0,     0,     0,     0,     0,    70,    71,    72,    73,    74,
     0,     0,     0,     0,   274,    63,    64,    65,    66,    67,
    68,    63,    64,    65,    66,    67,    68,     0,    70,    71,
    72,    73,    74,     0,    70,    71,    72,    73,    74,     0,
     0,     0,     0,   275,    63,    64,    65,    66,    67,    68,
     0,     0,     0,     0,     0,     0,     0,    70,    71,    72,
    73,    74,     0,     0,     0,     0,   276,     0,     0,     0,
     0,     0,   277,    63,    64,    65,    66,    67,    68,     0,
     0,     0,     0,     0,     0,     0,    70,    71,    72,    73,
    74,     0,     0,     0,     0,   304,    63,    64,    65,    66,
    67,    68,    63,    64,    65,    66,    67,    68,     0,    70,
    71,    72,    73,    74,     0,    70,    71,    72,    73,    74,
     0,     0,     0,     0,   306,    63,    64,    65,    66,    67,
    68,     0,     0,     0,     0,     0,     0,     0,    70,    71,
    72,    73,    74,     0,     0,     0,     0,   307,     0,     0,
     0,     0,     0,   308,    63,    64,    65,    66,    67,    68,
     0,     0,     0,     0,     0,     0,     0,    70,    71,    72,
    73,    74,     0,     0,     0,     0,   309,    63,    64,    65,
    66,    67,    68,    63,    64,    65,    66,    67,    68,     0,
    70,    71,    72,    73,    74,     0,    70,    71,    72,    73,
    74,     0,     0,     0,     0,   315,    63,    64,    65,    66,
    67,    68,     0,     0,     0,     0,     0,     0,     0,    70,
    71,    72,    73,    74,     0,     0,     0,     0,   316,     0,
     0,     0,     0,     0,   317,    63,    64,    65,    66,    67,
    68,     0,     0,     0,     0,     0,     0,     0,    70,    71,
    72,    73,    74,     0,     0,     0,     0,   318,    63,    64,
    65,    66,    67,    68,    63,    64,    65,    66,    67,    68,
     0,    70,    71,    72,    73,    74,     0,    70,    71,    72,
    73,    74,     0,     0,     0,     0,   319,    63,    64,    65,
    66,    67,    68,     0,     0,     0,     0,     0,     0,     0,
    70,    71,    72,    73,    74,     0,     0,     0,     0,   334,
     0,     0,     0,     0,     0,   335,    63,    64,    65,    66,
    67,    68,     0,     0,     0,     0,     0,     0,     0,    70,
    71,    72,    73,    74,     0,     0,     0,     0,   336,    63,
    64,    65,    66,    67,    68,    63,    64,    65,    66,    67,
    68,     0,    70,    71,    72,    73,    74,     0,    70,    71,
    72,    73,    74,     0,     0,     0,     0,   337,    63,    64,
    65,    66,    67,    68,     0,     0,     0,     0,     0,     0,
     0,    70,    71,    72,    73,    74,     0,     0,     0,     0,
   338,     0,     0,     0,     0,     0,   340,    63,    64,    65,
    66,    67,    68,     0,     0,     0,     0,     0,     0,     0,
    70,    71,    72,    73,    74,     0,     0,     0,     0,   341,
    63,    64,    65,    66,    67,    68,    63,    64,    65,    66,
    67,    68,     0,    70,    71,    72,    73,    74,     0,    70,
    71,    72,    73,    74,     0,     0,     0,     0,   342,    63,
    64,    65,    66,    67,    68,     0,     0,     0,     0,     0,
     0,     0,    70,    71,    72,    73,    74,     0,     0,     0,
     0,   343,     0,     0,     0,     0,     0,   354,    63,    64,
    65,    66,    67,    68,     0,     0,     0,     0,     0,     0,
     0,    70,    71,    72,    73,    74,     0,     0,     0,     0,
   355,    63,    64,    65,    66,    67,    68,    63,    64,    65,
    66,    67,    68,     0,    70,    71,    72,    73,    74,     0,
    70,    71,    72,    73,    74,     0,     0,     0,     0,   358,
    63,    64,    65,    66,    67,    68,     0,     0,     0,     0,
     0,     0,     0,    70,    71,    72,    73,    74,     0,     0,
     0,     0,   359,     0,     0,     0,     0,     0,   360,    63,
    64,    65,    66,    67,    68,     0,     0,     0,     0,     0,
     0,     0,    70,    71,    72,    73,    74,     0,     0,     0,
     0,   367,    63,    64,    65,    66,    67,    68,    63,    64,
    65,    66,    67,    68,     0,    70,    71,    72,    73,    74,
     0,    70,    71,    72,    73,    74,     0,     0,     0,     0,
   369,    63,    64,    65,    66,    67,    68,     0,     0,     0,
     0,     0,     0,     0,    70,    71,    72,    73,    74,     0,
     0,     0,     0,   370,     0,     0,     0,     0,     0,   374,
    63,    64,    65,    66,    67,    68,     0,     0,     0,     0,
     0,     0,     0,    70,    71,    72,    73,    74,     0,     0,
     0,     0,   376,    63,    64,    65,    66,    67,    68,    63,
    64,    65,    66,    67,    68,     0,    70,    71,    72,    73,
    74,     0,    70,    71,    72,    73,    74,     0,     0,     0,
     0,   379,    63,    64,    65,    66,    67,    68,     0,     0,
     0,     0,     0,     0,     0,    70,    71,    72,    73,    74,
     0,     0,     0,     0,   380,     0,     0,     0,     0,     0,
   384,    63,    64,    65,    66,    67,    68,     0,     0,     0,
     0,     0,     0,     0,    70,    71,    72,    73,    74,     0,
     0,     0,   112,    63,    64,    65,    66,    67,    68,    63,
    64,    65,    66,    67,    68,     0,    70,    71,    72,    73,
    74,     0,    70,    71,    72,    73,    74,     0,     0,     0,
     0,   163,    63,    64,    65,    66,    67,    68,     0,    63,
    64,    65,    66,    67,    68,    70,    71,    72,    73,    74,
     0,     0,    70,   203,    72,    73,    74,     0,     0,   219,
    63,    64,    65,    66,    67,    68,     0,     0,     0,     0,
     0,     0,     0,    70,    71,    72,    73,    74,     0,     0,
     0,     0,   224,    63,    64,    65,    66,    67,    68,    63,
    64,    65,    66,    67,    68,     0,    70,    71,    72,    73,
    74,     0,    70,    71,    72,    73,    74,     0,     0,     0,
   270,    63,    64,    65,    66,    67,    68,     0,     0,     0,
     0,     0,     0,     0,    70,    71,    72,    73,    74,     0,
     0,     0,     0,   271,     0,     0,     0,     0,     0,   272,
    63,    64,    65,    66,    67,    68,     0,     0,     0,     0,
     0,     0,     0,    70,    71,    72,    73,    74,     0,     0,
     0,   278,    63,    64,    65,    66,    67,    68,    63,    64,
    65,    66,    67,    68,     0,    70,    71,    72,    73,    74,
     0,    70,    71,    72,    73,    74,     0,     0,     0,     0,
   305,    63,    64,    65,    66,    67,    68,     0,     0,     0,
     0,     0,     0,     0,    70,    71,    72,    73,    74,     0,
     0,     0,   332,     0,     0,     0,     0,     0,   333,    63,
    64,    65,    66,    67,    68,     0,     0,     0,     0,     0,
     0,     0,    70,    71,    72,    73,    74,     0,     0,     0,
     0,   339,    63,    64,    65,    66,    67,    68,    63,    64,
    65,    66,    67,    68,     0,    70,    71,    72,    73,    74,
     0,    70,    71,    72,    73,    74,     0,     0,     0,   353,
    63,    64,    65,    66,    67,    68,     0,     0,     0,     0,
     0,     0,     0,    70,    71,    72,    73,    74,     0,     0,
     0,     0,   356,     0,     0,     0,     0,     0,   357,    63,
    64,    65,    66,    67,    68,     0,     0,     0,     0,     0,
     0,     0,    70,    71,    72,    73,    74,     0,     0,     0,
   366,    63,    64,    65,    66,    67,    68,    63,    64,    65,
    66,    67,    68,     0,    70,    71,    72,    73,    74,     0,
    70,    71,    72,    73,    74,     0,     0,     0,     0,   368,
    63,    64,    65,    66,    67,    68,     0,     0,     0,     0,
     0,     0,     0,    70,    71,    72,    73,    74,     0,     0,
     0,   375,     0,     1,     0,     0,     0,   383,     0,     0,
     2,     3,     4,     5,     0,     0,     0,     0,     0,     0,
     6,     7,     8,     9,    10,     0,     0,     0,     0,     0,
   386,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
     1,    30,     0,     0,     0,     0,     0,     0,     0,    63,
    64,    65,    66,    67,    68,     0,     0,     6,     0,     0,
     0,    69,    70,    71,    72,    73,    74,     0,    11,    12,
     0,    14,    75,    76,    77,    78,    79,    80,     0,     0,
    23,    24,     0,    26,     0,     0,     0,     0,    34,    63,
    64,    65,    66,    67,    68,     0,     0,     0,     0,     0,
     0,    69,    70,    71,    72,    73,    74,     0,     0,     0,
     0,     0,    75,    76,    77,    78,    63,    64,    65,    66,
    67,    68,     0,     0,     0,     0,     0,     0,     0,    70,
    71,    72,    73,    74
};

static const short yycheck[] = {     0,
     1,    43,    52,    34,    52,     6,     9,    10,     5,     6,
     7,     8,    52,    13,    14,    46,    52,    48,    44,    45,
    52,    52,    30,    31,    24,    25,    51,    30,    31,    30,
     3,     2,    52,    34,     3,    52,    36,    37,    38,    39,
    40,    42,    43,    44,    45,    52,     3,    48,    49,    50,
    51,    52,    53,    26,    27,    28,    29,    30,    31,    30,
    61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    30,    51,    55,    54,    53,     9,    55,    88,    59,    60,
    61,    62,     3,    53,    54,    51,    46,    47,    55,    52,
     3,     4,     5,     6,     7,     8,    30,    31,    79,    80,
    53,    54,   113,    16,    17,    18,    19,    20,    52,     9,
    10,    53,    54,    52,    52,     3,    52,   128,   129,   130,
    52,    81,    82,    83,    84,    85,    86,    87,    52,    52,
    30,    31,    53,    52,    55,     4,    54,    54,    54,    99,
    53,     7,    54,   154,    57,   156,   157,    53,   159,   160,
   161,   162,    21,   164,    54,    53,    52,   168,   169,   170,
   171,   172,   173,    32,    33,    53,    35,    55,   179,    54,
   181,    55,    51,   184,   185,    44,    45,   188,    47,    15,
    53,     9,    10,    52,    53,     9,    10,    52,    57,    52,
    52,    52,    52,   174,    52,    52,    52,   208,    52,    51,
    51,   212,    30,    31,    54,    53,    30,    31,     0,   220,
   221,   222,   223,     0,   225,   226,   227,   228,   229,   230,
     3,     4,     5,     6,     7,     8,    54,   185,    -1,    53,
   282,   283,     3,     4,     5,     6,     7,     8,     3,     4,
     5,     6,     7,     8,    -1,    16,    17,    18,    19,    20,
   231,    16,    17,    18,    19,    20,    -1,    -1,   269,     9,
    10,    -1,   273,   274,   275,   276,   277,    -1,    -1,    -1,
    -1,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
    30,    31,    -1,    -1,    -1,    56,    57,    -1,    53,    -1,
    -1,    -1,    57,   304,    -1,   306,   307,   308,   309,   310,
    -1,    -1,   313,    53,   315,   316,   317,   318,   319,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
     6,     7,     8,   334,   335,   336,   337,   338,    -1,   340,
   341,   342,   343,    19,    20,    -1,    -1,     3,     4,     5,
     6,     7,     8,   354,   355,    -1,    -1,   358,   359,   360,
    16,    17,    18,    19,    20,    -1,   367,    -1,   369,   370,
    -1,    -1,    -1,   374,    -1,   376,    -1,    -1,   379,   380,
    -1,    -1,    -1,   384,    -1,    -1,    -1,    -1,    -1,     3,
     4,     5,     6,     7,     8,    -1,    -1,    53,    -1,    -1,
    -1,    57,    16,    17,    18,    19,    20,     3,     4,     5,
     6,     7,     8,     3,     4,     5,     6,     7,     8,    -1,
    16,    17,    18,    19,    20,    -1,    16,    17,    18,    19,
    20,     3,     4,     5,     6,     7,     8,    -1,    -1,    53,
    -1,    -1,    -1,    57,    16,    17,    18,    19,    20,     3,
     4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
     8,    57,    16,    17,    18,    19,    20,    57,    16,    17,
    18,    19,    20,    -1,    -1,     4,    -1,    -1,    -1,    -1,
    -1,    53,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    21,    -1,    -1,    -1,     3,     4,     5,     6,
     7,     8,    56,    32,    33,     4,    35,    -1,    56,    16,
    17,    18,    19,    20,    -1,    44,    45,    -1,    47,    -1,
    -1,     4,    21,    52,    53,    -1,    -1,    -1,    57,    -1,
    -1,    -1,    -1,    32,    33,    -1,    35,    -1,    21,    -1,
    -1,    -1,    -1,    -1,    -1,    44,    45,    54,    47,    32,
    33,     4,    35,    52,    53,     4,    -1,    -1,    57,    -1,
    -1,    44,    45,    -1,    47,    -1,    -1,    -1,    21,    52,
    53,    -1,    21,    -1,    57,    -1,    -1,    -1,    -1,    32,
    33,    -1,    35,    32,    33,     4,    35,    -1,    -1,    -1,
    -1,    44,    45,    12,    47,    44,    45,    -1,    47,    52,
    -1,     4,    21,    52,    57,    -1,    -1,    -1,    57,    -1,
    -1,    -1,    -1,    32,    33,    -1,    35,     4,    21,    -1,
    -1,    -1,    -1,    -1,    -1,    44,    45,    -1,    47,    32,
    33,    -1,    35,    52,    21,    -1,    55,    56,    -1,     4,
    -1,    44,    45,    -1,    47,    32,    33,    -1,    35,    52,
     3,    -1,    55,    56,    -1,     4,    21,    44,    45,    -1,
    47,    -1,    -1,    -1,    -1,    52,    -1,    32,    33,    56,
    35,    -1,    21,    26,    27,    28,    29,    30,    31,    44,
    45,    -1,    47,    32,    33,    -1,    35,    52,    -1,    -1,
    -1,    56,    -1,    -1,    -1,    44,    45,    -1,    47,    -1,
    53,    -1,    55,    52,    -1,    -1,    -1,    56,     3,     4,
     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,
    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
    -1,    26,    27,    28,    29,    30,    31,     3,     4,     5,
     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    16,    17,    18,    19,    20,    -1,    -1,    -1,    53,    54,
     3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
     7,     8,    -1,    16,    17,    18,    19,    20,    -1,    16,
    17,    18,    19,    20,    -1,    -1,    -1,    -1,    54,     3,
     4,     5,     6,     7,     8,    -1,     3,     4,     5,     6,
     7,     8,    16,    17,    18,    19,    20,    -1,    -1,    16,
    -1,    54,    19,    20,    -1,    -1,    -1,    54,     3,     4,
     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
    54,     3,     4,     5,     6,     7,     8,     3,     4,     5,
     6,     7,     8,    -1,    16,    17,    18,    19,    20,    -1,
    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    54,
     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    54,     3,
     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    -1,    54,     3,     4,     5,     6,     7,     8,     3,     4,
     5,     6,     7,     8,    -1,    16,    17,    18,    19,    20,
    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
    54,     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,
    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    54,
     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    54,     3,     4,     5,     6,     7,     8,     3,
     4,     5,     6,     7,     8,    -1,    16,    17,    18,    19,
    20,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    -1,    54,     3,     4,     5,     6,     7,     8,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,
    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
    54,     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,
    -1,    -1,    -1,    54,     3,     4,     5,     6,     7,     8,
     3,     4,     5,     6,     7,     8,    -1,    16,    17,    18,
    19,    20,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    54,     3,     4,     5,     6,     7,     8,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,
    20,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,
    -1,    54,     3,     4,     5,     6,     7,     8,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,
    -1,    -1,    -1,    -1,    54,     3,     4,     5,     6,     7,
     8,     3,     4,     5,     6,     7,     8,    -1,    16,    17,
    18,    19,    20,    -1,    16,    17,    18,    19,    20,    -1,
    -1,    -1,    -1,    54,     3,     4,     5,     6,     7,     8,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,
    19,    20,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
    -1,    -1,    54,     3,     4,     5,     6,     7,     8,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,
    20,    -1,    -1,    -1,    -1,    54,     3,     4,     5,     6,
     7,     8,     3,     4,     5,     6,     7,     8,    -1,    16,
    17,    18,    19,    20,    -1,    16,    17,    18,    19,    20,
    -1,    -1,    -1,    -1,    54,     3,     4,     5,     6,     7,
     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,
    18,    19,    20,    -1,    -1,    -1,    -1,    54,    -1,    -1,
    -1,    -1,    -1,    54,     3,     4,     5,     6,     7,     8,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,
    19,    20,    -1,    -1,    -1,    -1,    54,     3,     4,     5,
     6,     7,     8,     3,     4,     5,     6,     7,     8,    -1,
    16,    17,    18,    19,    20,    -1,    16,    17,    18,    19,
    20,    -1,    -1,    -1,    -1,    54,     3,     4,     5,     6,
     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,
    17,    18,    19,    20,    -1,    -1,    -1,    -1,    54,    -1,
    -1,    -1,    -1,    -1,    54,     3,     4,     5,     6,     7,
     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,
    18,    19,    20,    -1,    -1,    -1,    -1,    54,     3,     4,
     5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
    -1,    16,    17,    18,    19,    20,    -1,    16,    17,    18,
    19,    20,    -1,    -1,    -1,    -1,    54,     3,     4,     5,
     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    54,
    -1,    -1,    -1,    -1,    -1,    54,     3,     4,     5,     6,
     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,
    17,    18,    19,    20,    -1,    -1,    -1,    -1,    54,     3,
     4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
     8,    -1,    16,    17,    18,    19,    20,    -1,    16,    17,
    18,    19,    20,    -1,    -1,    -1,    -1,    54,     3,     4,
     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
    54,    -1,    -1,    -1,    -1,    -1,    54,     3,     4,     5,
     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    54,
     3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
     7,     8,    -1,    16,    17,    18,    19,    20,    -1,    16,
    17,    18,    19,    20,    -1,    -1,    -1,    -1,    54,     3,
     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    -1,    54,    -1,    -1,    -1,    -1,    -1,    54,     3,     4,
     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
    54,     3,     4,     5,     6,     7,     8,     3,     4,     5,
     6,     7,     8,    -1,    16,    17,    18,    19,    20,    -1,
    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    54,
     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    54,     3,
     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    -1,    54,     3,     4,     5,     6,     7,     8,     3,     4,
     5,     6,     7,     8,    -1,    16,    17,    18,    19,    20,
    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
    54,     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,
    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    54,
     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    54,     3,     4,     5,     6,     7,     8,     3,
     4,     5,     6,     7,     8,    -1,    16,    17,    18,    19,
    20,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    -1,    54,     3,     4,     5,     6,     7,     8,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,
    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
    54,     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,
    -1,    -1,    53,     3,     4,     5,     6,     7,     8,     3,
     4,     5,     6,     7,     8,    -1,    16,    17,    18,    19,
    20,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    -1,    53,     3,     4,     5,     6,     7,     8,    -1,     3,
     4,     5,     6,     7,     8,    16,    17,    18,    19,    20,
    -1,    -1,    16,    53,    18,    19,    20,    -1,    -1,    53,
     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    53,     3,     4,     5,     6,     7,     8,     3,
     4,     5,     6,     7,     8,    -1,    16,    17,    18,    19,
    20,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    53,     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,
    -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,    53,
     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    53,     3,     4,     5,     6,     7,     8,     3,     4,
     5,     6,     7,     8,    -1,    16,    17,    18,    19,    20,
    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
    53,     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,
    -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,    53,     3,
     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    -1,    53,     3,     4,     5,     6,     7,     8,     3,     4,
     5,     6,     7,     8,    -1,    16,    17,    18,    19,    20,
    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,    53,
     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,    53,     3,
     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    53,     3,     4,     5,     6,     7,     8,     3,     4,     5,
     6,     7,     8,    -1,    16,    17,    18,    19,    20,    -1,
    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    53,
     3,     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    16,    17,    18,    19,    20,    -1,    -1,
    -1,    53,    -1,     4,    -1,    -1,    -1,    53,    -1,    -1,
    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
    53,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
     4,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
     4,     5,     6,     7,     8,    -1,    -1,    21,    -1,    -1,
    -1,    15,    16,    17,    18,    19,    20,    -1,    32,    33,
    -1,    35,    26,    27,    28,    29,    30,    31,    -1,    -1,
    44,    45,    -1,    47,    -1,    -1,    -1,    -1,    52,     3,
     4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,
    -1,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
    -1,    -1,    26,    27,    28,    29,     3,     4,     5,     6,
     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,
    17,    18,    19,    20
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/local/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 129 "SelectParser.y"
{ selectorGlobals->selExpression = yyvsp[0].yNode;
								  selectorGlobals->isSelExprLogic = true; ;
    break;}
case 2:
#line 131 "SelectParser.y"
{ selectorGlobals->selExpression = yyvsp[0].yNode;
								  selectorGlobals->isSelExprLogic = false; ;
    break;}
case 3:
#line 134 "SelectParser.y"
{ yyval.yNode = new TrueNode; ;
    break;}
case 4:
#line 135 "SelectParser.y"
{ yyval.yNode = new FalseNode; ;
    break;}
case 5:
#line 136 "SelectParser.y"
{ yyval.yNode = yyvsp[0].yNode; ;
    break;}
case 6:
#line 137 "SelectParser.y"
{ yyval.yNode = new OrIf(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 7:
#line 138 "SelectParser.y"
{ yyval.yNode = new AndIf(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 8:
#line 139 "SelectParser.y"
{ yyval.yNode = new Not(yyvsp[0].yNode); ;
    break;}
case 9:
#line 140 "SelectParser.y"
{ yyval.yNode = new Eq(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 10:
#line 141 "SelectParser.y"
{ yyval.yNode = new Eq(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 11:
#line 142 "SelectParser.y"
{ yyval.yNode = new Eq(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 12:
#line 143 "SelectParser.y"
{ yyval.yNode = new Eq(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 13:
#line 144 "SelectParser.y"
{ yyval.yNode = new Ne(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 14:
#line 145 "SelectParser.y"
{ yyval.yNode = new Ne(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 15:
#line 146 "SelectParser.y"
{ yyval.yNode = new Ne(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 16:
#line 147 "SelectParser.y"
{ yyval.yNode = new Ne(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 17:
#line 148 "SelectParser.y"
{ yyval.yNode = new Lt(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 18:
#line 149 "SelectParser.y"
{ yyval.yNode = new Le(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 19:
#line 150 "SelectParser.y"
{ yyval.yNode = new Gt(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 20:
#line 151 "SelectParser.y"
{ yyval.yNode = new Ge(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 21:
#line 152 "SelectParser.y"
{ yyval.yNode = yyvsp[-1].yNode; ;
    break;}
case 22:
#line 153 "SelectParser.y"
{ yyval.yNode = new StrEq(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 23:
#line 154 "SelectParser.y"
{ yyval.yNode = new StrNe(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 24:
#line 155 "SelectParser.y"
{ yyval.yNode = new StrLt(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 25:
#line 156 "SelectParser.y"
{ yyval.yNode = new StrLe(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 26:
#line 157 "SelectParser.y"
{ yyval.yNode = new StrGt(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 27:
#line 158 "SelectParser.y"
{ yyval.yNode = new StrGe(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 28:
#line 160 "SelectParser.y"
{ yyval.yNode = yyvsp[-7].yNode;
								  OpNode nd[] = { yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-7].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 29:
#line 164 "SelectParser.y"
{ yyval.yNode = yyvsp[-7].yNode;
								  OpNode nd[] = { yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-7].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 30:
#line 168 "SelectParser.y"
{ yyval.yNode = yyvsp[-9].yNode;
								  OpNode nd[] = { yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-9].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 31:
#line 172 "SelectParser.y"
{ yyval.yNode = yyvsp[-5].yNode;
								  OpNode nd[] = { yyvsp[-3].yNode, yyvsp[-1].yNode, yyvsp[-10].yNode, yyvsp[-8].yNode };
								  yyvsp[-5].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 32:
#line 176 "SelectParser.y"
{ yyval.yNode = yyvsp[-11].yNode;
								  OpNode nd[] = { yyvsp[-9].yNode, yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-11].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 33:
#line 181 "SelectParser.y"
{ yyval.yNode = yyvsp[-7].yNode;
								  OpNode nd[] = { yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode, yyvsp[-12].yNode, yyvsp[-10].yNode };
								  yyvsp[-7].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 34:
#line 186 "SelectParser.y"
{ yyval.yNode = yyvsp[-13].yNode;
								  OpNode nd[] = { yyvsp[-11].yNode, yyvsp[-9].yNode, yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-13].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 35:
#line 191 "SelectParser.y"
{ yyval.yNode = yyvsp[-9].yNode;
								  OpNode nd[] = { yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode, yyvsp[-14].yNode, yyvsp[-12].yNode };
								  yyvsp[-9].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 36:
#line 195 "SelectParser.y"
{ yyval.yNode = yyvsp[-15].yNode;
								  OpNode nd[] = { yyvsp[-13].yNode, yyvsp[-11].yNode, yyvsp[-9].yNode, yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode,
								  yyvsp[-1].yNode };
								  yyvsp[-15].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 37:
#line 201 "SelectParser.y"
{ yyval.yNode = yyvsp[-11].yNode;
								  OpNode nd[] = { yyvsp[-9].yNode, yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode,
												  yyvsp[-16].yNode, yyvsp[-14].yNode };
								  yyvsp[-11].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 38:
#line 207 "SelectParser.y"
{ yyval.yNode = yyvsp[-21].yNode;
								  OpNode nd[] = { yyvsp[-19].yNode, yyvsp[-17].yNode, yyvsp[-15].yNode, yyvsp[-13].yNode, yyvsp[-11].yNode, yyvsp[-9].yNode,
												  yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-21].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 39:
#line 214 "SelectParser.y"
{ yyval.yNode = yyvsp[-17].yNode;
								  OpNode nd[] = { yyvsp[-15].yNode, yyvsp[-13].yNode, yyvsp[-11].yNode, yyvsp[-9].yNode, yyvsp[-7].yNode, yyvsp[-5].yNode,
												  yyvsp[-3].yNode, yyvsp[-1].yNode, yyvsp[-22].yNode, yyvsp[-20].yNode };
								  yyvsp[-17].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 40:
#line 219 "SelectParser.y"
{ yyval.yNode =
									PolygonScope::newPolyFilter(yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 41:
#line 222 "SelectParser.y"
{ yyval.yNode =
									PolygonScope::newPolyFilter(yyvsp[-1].yNode, yyvsp[-8].yNode, yyvsp[-6].yNode); ;
    break;}
case 42:
#line 225 "SelectParser.y"
{ yyval.yNode =
									PolygonScope::newPolyFilter(yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode,
																true); ;
    break;}
case 43:
#line 229 "SelectParser.y"
{ yyval.yNode =
									PolygonScope::newPolyFilter(yyvsp[-1].yNode, yyvsp[-8].yNode, yyvsp[-6].yNode,
																true); ;
    break;}
case 44:
#line 233 "SelectParser.y"
{ prependSetName(yyvsp[-3].yFileName);
								  yyval.yNode = GtiFilter::expandGtis(*yyvsp[-3].yFileName, yyvsp[-1].yNode);
								  delete yyvsp[-3].yFileName; ;
    break;}
case 45:
#line 237 "SelectParser.y"
{ prependSetName(yyvsp[-1].yFileName);
								  yyval.yNode = GtiFilter::expandGtis(*yyvsp[-1].yFileName, yyvsp[-5].yNode);
								  delete yyvsp[-1].yFileName; ;
    break;}
case 46:
#line 241 "SelectParser.y"
{ prependSetName(yyvsp[-5].yFileName);
								  yyval.yNode = RegionFilter::expandRegion(*yyvsp[-5].yFileName, yyvsp[-3].yNode, yyvsp[-1].yNode);
								  delete yyvsp[-5].yFileName; ;
    break;}
case 47:
#line 245 "SelectParser.y"
{ prependSetName(yyvsp[-1].yFileName);
								  yyval.yNode = RegionFilter::expandRegion(*yyvsp[-1].yFileName);
								  delete yyvsp[-1].yFileName; ;
    break;}
case 48:
#line 249 "SelectParser.y"
{ prependSetName(yyvsp[-1].yFileName);
								  yyval.yNode = RegionFilter::expandRegion(*yyvsp[-1].yFileName, yyvsp[-8].yNode, yyvsp[-6].yNode);
								  delete yyvsp[-1].yFileName; ;
    break;}
case 49:
#line 253 "SelectParser.y"
{ prependSetName(yyvsp[-9].yFileName);
								  yyval.yNode = new MaskFilter(*yyvsp[-9].yFileName, yyvsp[-7].yNode, yyvsp[-5].yNode, yyvsp[-3].yNode, yyvsp[-1].yNode);
								  delete yyvsp[-9].yFileName; ;
    break;}
case 50:
#line 257 "SelectParser.y"
{ prependSetName(yyvsp[-5].yFileName);
								  yyval.yNode = new MaskFilter(*yyvsp[-5].yFileName, yyvsp[-3].yNode, yyvsp[-1].yNode, yyvsp[-12].yNode, yyvsp[-10].yNode);
								  delete yyvsp[-5].yFileName; ;
    break;}
case 51:
#line 260 "SelectParser.y"
{ yyval.yNode = yyvsp[0].yNode;
								  OpNode nd[] = { yyvsp[-2].yNode };
								  yyvsp[0].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 52:
#line 263 "SelectParser.y"
{ const TableDescriptor *tab =
									selectorGlobals->tableDescriptor;
								  if (tab &&
									  tab->column(yyvsp[-1].yNode->name())->nullDefined())
									  yyval.yNode = new Eq(yyvsp[-1].yNode, new NumericLiteral(DBL(
										  tab->column(yyvsp[-1].yNode->name())->
															nullValue())));
								  else
									  yyval.yNode = new FalseNode; ;
    break;}
case 53:
#line 272 "SelectParser.y"
{ yyval.yNode = new NanOp(yyvsp[-1].yNode); ;
    break;}
case 55:
#line 275 "SelectParser.y"
{ yyval.yNode = new Add(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 56:
#line 276 "SelectParser.y"
{ yyval.yNode = new Sub(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 57:
#line 277 "SelectParser.y"
{ yyval.yNode = new Mul(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 58:
#line 278 "SelectParser.y"
{ yyval.yNode = new Div(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 59:
#line 279 "SelectParser.y"
{ yyval.yNode = new Modulo(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 60:
#line 280 "SelectParser.y"
{ yyval.yNode = new Expo(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 61:
#line 281 "SelectParser.y"
{ yyval.yNode = new And(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 62:
#line 282 "SelectParser.y"
{ yyval.yNode = new Or(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 63:
#line 283 "SelectParser.y"
{ yyval.yNode = new Xor(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 64:
#line 284 "SelectParser.y"
{ yyval.yNode = new Lshift(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 65:
#line 285 "SelectParser.y"
{ yyval.yNode = new Rshift(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 66:
#line 286 "SelectParser.y"
{ yyval.yNode = new Bitcompl(yyvsp[0].yNode); ;
    break;}
case 67:
#line 287 "SelectParser.y"
{ yyval.yNode = yyvsp[-3].yNode;
								  OpNode nd[] = { yyvsp[-1].yNode };
								  yyvsp[-3].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 68:
#line 291 "SelectParser.y"
{ yyval.yNode = yyvsp[-5].yNode;
								  OpNode nd[] = { yyvsp[-3].yNode, yyvsp[-1].yNode };
								  yyvsp[-5].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 69:
#line 294 "SelectParser.y"
{ yyval.yNode = new Uminus(yyvsp[0].yNode); ;
    break;}
case 70:
#line 295 "SelectParser.y"
{ yyval.yNode = yyvsp[-3].yNode;
								  OpNode nd[] = { yyvsp[-1].yNode };
								  yyvsp[-3].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 71:
#line 298 "SelectParser.y"
{ yyval.yNode = yyvsp[-1].yNode; ;
    break;}
case 75:
#line 303 "SelectParser.y"
{ yyval.yNode = new StrRange(false, false); ;
    break;}
case 76:
#line 304 "SelectParser.y"
{ yyval.yNode = new StrRange(true, false, yyvsp[-2].yNode); ;
    break;}
case 77:
#line 305 "SelectParser.y"
{ yyval.yNode = new StrRange(false, true, yyvsp[-1].yNode); ;
    break;}
case 78:
#line 306 "SelectParser.y"
{ yyval.yNode = new StrRange(true, true, yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 79:
#line 308 "SelectParser.y"
{ yyval.yNode = yyvsp[-3].yNode;
								  yyvsp[-3].yNode->textLengthMax(yyvsp[-1].yNode->textLength());
								  OpNode nd[] = { yyvsp[-1].yNode };
								  yyvsp[-3].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 80:
#line 312 "SelectParser.y"
{ yyval.yNode = yyvsp[0].yNode;
								  OpNode nd[] = { yyvsp[-1].yNode };
								  yyvsp[0].yNode->textLengthMax(yyvsp[-1].yNode->textLength());
								  /* register text as 3rd child */
								  yyvsp[0].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 81:
#line 317 "SelectParser.y"
{ yyval.yNode = new StrConcat(yyvsp[-2].yNode, yyvsp[0].yNode);
								  yyval.yNode->textLengthMax(yyvsp[-2].yNode->textLength() +
													yyvsp[0].yNode->textLength()); ;
    break;}
case 82:
#line 320 "SelectParser.y"
{ yyval.yNode = yyvsp[-1].yNode; ;
    break;}
case 85:
#line 325 "SelectParser.y"
{ yyval.yNode = yyvsp[-4].yNode;
								  yyvsp[-4].yNode->addPoint(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 86:
#line 327 "SelectParser.y"
{ yyval.yNode = new NodePointList;
								  yyval.yNode->addPoint(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 87:
#line 331 "SelectParser.y"
{ yyval.yNode = yyvsp[-2].yNode;
								  OpNode nd[] = { yyvsp[0].yNode };
								  yyvsp[-2].yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 88:
#line 334 "SelectParser.y"
{ yyval.yNode = new InInterval;
								  OpNode nd[] = { yyvsp[0].yNode };
								  yyval.yNode->addChildren(NUM_OF(nd), nd); ;
    break;}
case 89:
#line 338 "SelectParser.y"
{ yyval.yNode = new IntTrue; ;
    break;}
case 90:
#line 339 "SelectParser.y"
{ yyval.yNode = new IntTrue; ;
    break;}
case 91:
#line 340 "SelectParser.y"
{ yyval.yNode = new IntTrue; ;
    break;}
case 92:
#line 341 "SelectParser.y"
{ yyval.yNode = new IntTrue; ;
    break;}
case 93:
#line 342 "SelectParser.y"
{ yyval.yNode = new IntTrue; ;
    break;}
case 94:
#line 343 "SelectParser.y"
{ yyval.yNode = new IntEq(yyvsp[0].yNode); ;
    break;}
case 95:
#line 344 "SelectParser.y"
{ yyval.yNode = new IntEq(yyvsp[-1].yNode); ;
    break;}
case 96:
#line 345 "SelectParser.y"
{ yyval.yNode = new IntLe(yyvsp[-1].yNode); ;
    break;}
case 97:
#line 346 "SelectParser.y"
{ yyval.yNode = new IntLe(yyvsp[-2].yNode); ;
    break;}
case 98:
#line 347 "SelectParser.y"
{ yyval.yNode = new IntLe(yyvsp[-2].yNode); ;
    break;}
case 99:
#line 348 "SelectParser.y"
{ yyval.yNode = new IntLt(yyvsp[-2].yNode); ;
    break;}
case 100:
#line 349 "SelectParser.y"
{ yyval.yNode = new IntLt(yyvsp[-2].yNode); ;
    break;}
case 101:
#line 350 "SelectParser.y"
{ yyval.yNode = new IntGe(yyvsp[0].yNode); ;
    break;}
case 102:
#line 351 "SelectParser.y"
{ yyval.yNode = new IntGe(yyvsp[-1].yNode); ;
    break;}
case 103:
#line 352 "SelectParser.y"
{ yyval.yNode = new IntGt(yyvsp[-1].yNode); ;
    break;}
case 104:
#line 353 "SelectParser.y"
{ yyval.yNode = new IntGe(yyvsp[-1].yNode); ;
    break;}
case 105:
#line 354 "SelectParser.y"
{ yyval.yNode = new IntGt(yyvsp[-1].yNode); ;
    break;}
case 106:
#line 355 "SelectParser.y"
{ yyval.yNode = new IntCC(yyvsp[-2].yNode, yyvsp[0].yNode); ;
    break;}
case 107:
#line 356 "SelectParser.y"
{ yyval.yNode = new IntCC(yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 108:
#line 357 "SelectParser.y"
{ yyval.yNode = new IntOC(yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 109:
#line 358 "SelectParser.y"
{ yyval.yNode = new IntCO(yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
case 110:
#line 359 "SelectParser.y"
{ yyval.yNode = new IntOO(yyvsp[-3].yNode, yyvsp[-1].yNode); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/local/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 361 "SelectParser.y"


}
