//---------------------------------------------------------------------------
//
//                     XMM Science Analysis System (SAS)
//                    (c) 1997-2010 European Space Agency
//
//---------------------------------------------------------------------------
//
//	TableDescriptor.h: --- a class that provides table inquiry functions
//
//	DESCRIPTION:
//		Some table inquiry functions
//
//	CHANGE HISTORY:
//		UL, 2000-06-30: 1.0.0: - first version
//
//	AUTHOR:
//		U. Lammers (UL), Thu Jun 29 16:21:51 MET DST 2000
//
//	$Header: /data/xmm02/cvsadmin/soc_repos/sas/packages/selectlib/src/selcore/TableDescriptor.h,v 1.2 2001/08/10 16:14:57 ulammers Exp $
///

#ifndef TABLE_DESCRIPTOR_H
#define TABLE_DESCRIPTOR_H

#include "Dal.h"
#include <string>

class ColumnDescriptor {
public:
	virtual bool isNumeric() const { return isInteger()	||
											isReal() ||
											isBool(); }
	virtual bool isInteger() const = 0;
	virtual bool isReal() const = 0;
	virtual bool isBool() const = 0;
	
	virtual unsigned length() const = 0;
	virtual bool nullDefined() const = 0;
	virtual long nullValue() const = 0;
};

class TableDescriptor {
public:
	virtual std::string	name() const = 0;
	virtual std::string	setName() const = 0;
	virtual bool	hasColumn(const std::string &name) const = 0;
	virtual ColumnDescriptor *column(const std::string &name) const = 0;
	virtual const Table *table() const = 0;
};

#endif
