//-----------------------------------------------------------------------------
//
//						XMM Science Analysis System (SAS)
//					   (c) 1997-2010 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	ServiceF90cxxGlue.h	--- the Fortran90/C++ interface of selector-services
//
//	DESCRIPTION:
//		This file acts as the interface between the filter/arrayeval services
//		declared in corresponding f90-modules and their implementation in
//		C++.
//
//	CHANGE HISTORY:
//		UL, 25/03/98: 1.0.0: - skeleton
//		UL, 28/05/98: 1.1.0: - added ArrayEvaluator
//
//	AUTHOR:
//		U. Lammers, Wed Mar 25 11:15:00 MET 1998
//
//
//	$Header: /data/xmm02/cvsadmin/soc_repos/sas/packages/selectlib/src/service/ServiceF90cxxGlue.h,v 1.1 2001/08/07 14:06:47 ulammers Exp $
//

#ifndef SERVICE_F90CPP_H
#define SERVICE_F90CPP_H

#include "common.h"
#include "f90cxx.h"
#include "Dal.h"

//
//	-------------------------( Filter )-----------------------------------
//
extern "C" void CXXFUNC(initfilter, initFilter)
							(const char *expression,
							 Integer3 expressionLength);

extern "C" Integer3 CXXFUNC(dofilter, doFilter)
							(Table *const *table);

extern "C" Integer3 CXXFUNC(doselectmodify, doSelectModify)
							(Table *const *table,
							 const char *flagColumnName,
							 const Integer2 *flagBitPos,
							 Integer3 flagColumnLength);

extern "C" Integer3 CXXFUNC(doselectconst, doSelectConst)
							(const Table *const *table,
							 Dope<Integer3, 1> *fromRow,
							 Dope<Integer3, 1> *toRow);

//
//	-----------------------( ArrayEvaluator )-----------------------------
//
extern "C" void CXXFUNC(initarrayeval, initArrayEval)
							(const char *expression,
							 Integer3 expressionLength);

extern "C" void CXXFUNC(doarrayeval, doArrayEval)
							(Dope<Array *, 1> *inArray,
							 Integer3 *lenInArray,
							 Array **outArray);

#endif

