!
!   arrayevaltestf90.f90: test the F90 wrapper for ArrayEvaluator class
!
!   UL, Thu May 28 15:41:28 MET DST 1998
!
!   $Header: /data/xmm02/cvsadmin/soc_repos/sas/packages/selectlib/test/arrayevaltestf90.f90,v 1.4 2000/06/22 12:35:00 ulammers Exp $
!
program arrayevaltestf90
    use dal
    use errorhandling
    use arrayeval

    integer(kind=int32), parameter    :: DIM = 100
    integer(kind=int32), dimension(3) :: arrdim = (/DIM, DIM, DIM/)
    integer(kind=int32), dimension(:), pointer  :: ip
    real(kind=single), dimension(:), pointer    :: rp
    real(kind=double), dimension(:), pointer    :: dp
    type(ArrayT), dimension(0:1)                :: inArrays
    type(ArrayT)                                :: outArray

    type(DataSetT) :: set
    integer        :: n, nElements

    set = dataSet('a.ds', Temp);
    inArrays(0) = addArray(set, 'A1', INTEGER32, arrdim)
    inArrays(1) = addArray(set, 'A2', REAL32, arrdim)
    outArray = addArray(set, 'A3', REAL64, arrdim)

    nElements = numberOfElements(inArrays(0))
    ip => int32Data(inArrays(0))
    rp => real32Data(inArrays(1))
    do n=0, nElements-1
        ip(n) = n
        rp(n) = 2*n
    enddo

    !
    !   initialize the evaluator - we add the two arrays
    !
    call initArrayEval('A1+A2')

    !
    !   do it
    !
    call doArrayEval(inArrays, size(inArrays), outArray)

    dp => real64Data(outArray);
    do n=0, nElements-1
        if (dp(n) .ne. 3*n) &
            call fatal('arrayevaltestf90', 'arrayeval1: result not ok')
    enddo

    call release(set)

    call message(AppMsg, Verbose, 'all tests successfully passed')
end program
