//
//	ascregiontest: test the ASCregion class
//
//	UL, Wed Apr  1 11:23:29 MET DST 1998
//
//	$Header: /data/xmm02/cvsadmin/soc_repos/sas/packages/selectlib/test/ascregiontest.cc,v 1.6 2001/04/02 14:04:28 ulammers Exp $
//

#include <cassert>
#include <string>
#include <iostream>
#include "SelectUtils.h"

int main()
{
	OutASCregionTable	outtable("region.ds");
	GeoRegion				r;

	Component	c1, c2, c3, c4, c5, c6;

	//	component #1
	c1.push_back(new FRotBox(FPoint(250, 150), 200, 200, 45.));
	c1.push_back(new FCircle(FPoint(250, 150), 50, false));
	r.push_back(c1);

	//	component #2
	c2.push_back(new FRectangle(FPoint(50, 400), FPoint(100, 450)));
	r.push_back(c2);

	//	component #3
	c3.push_back(new FEllipse(FPoint(250, 400), 100, 40, 0., false));
	c3.push_back(new FEllipse(FPoint(250, 400), 100, 40, 90., false));
	c3.push_back(new FRectangle(FPoint(150, 300), FPoint(350, 500)));
	r.push_back(c3);

	//	component #4
	vector<float> x(6), y(6);
	x[0] = 430; x[1] = 480; x[2] = 505; x[3] = 470; x[4] = 410; x[5] = 430;
	y[0] = 410; y[1] = 440; y[2] = 490; y[3] = 505; y[4] = 460; y[5] = 410;
	c4.push_back(new FPolygon(x, y, x.size()));
	c4.push_back(new FPolygon(x, y, 4));
	c4.push_back(new FCircle(FPoint(450, 450), 20, false));

	r.push_back(c4);

	//	component #5
	c5.push_back(new FShape(FPoint(30, 40)));
	c5.push_back(new FShape(FPoint(50, 60)));
	c5.push_back(new FShape(FPoint(90, 100)));
	c5.push_back(new FShape(FPoint(134, 344)));
	c5.push_back(new FShape(FPoint(2, 45)));
	r.push_back(c5);

	// component #6
	c6.push_back(new FShape(FPoint(1, 1)));
	r.push_back(c6);

	outtable << r;

	//
	//	create another region file
	//
	OutASCregionTable	outtable2("region2.ds");
	GeoRegion				reg2;

	Component	cc1, cc2;

	//	component #1
	cc1.push_back(new FElliptAnnulus(FPoint(256, 256), 50, 30, 100, 60, 20.,
				  0.));
	cc1.push_back(new FSector(FPoint(256, 256), 165., 195., false));
	reg2.push_back(cc1);

	//	component #2
	cc2.push_back(new FSector(FPoint(256, 256), -20., 20.));
	cc2.push_back(new FCircle(FPoint(256, 256), 200));
	reg2.push_back(cc2);

	outtable2 << reg2;


	//
	//	and another one
	//
	OutASCregionTable	outtable3("region3.ds");
	Component		co(13);
	FPoint			pp(256, 256);
	co[0] = new FShape(pp);
	co[1] = new FCircle(pp, 101);
	co[2] = new FAnnulus(pp, 34, 323, false);
	co[3] = new FEllipse(pp, 103, 45, 23);
	co[4] = new FElliptAnnulus(pp, 30, 20, 45, 11, 10, 20, false);
	co[5] = new FBox(pp, 100, 50);
	co[6] = new FRotBox(pp, 234, 234, 23.);
	co[7] = new FRectangle(pp, FPoint(245, 545));
	co[8] = new FRotRectangle(pp, FPoint(213, 343), 20.);
	co[9] = new FRhombus(pp, 10, 23, false);
	co[10] = new FRotRhombus(pp, 11, 234, 24., false);
	co[11] = new FPolygon(x, y, x.size());
	co[12] = new FSector(pp, -123., 124., false);

	GeoRegion			reg3;
	reg3.push_back(co);
	outtable3<<reg3;

	return 0;
} // main

