//
//	errortest: check if the error handling works
//
//	UL, Wed Oct 13 19:01:18 MET DST 1999
//
//	$Header: /data/xmm02/cvsadmin/soc_repos/sas/packages/selectlib/test/errortest.cc,v 1.4 2001/08/10 16:15:03 ulammers Exp $
//

#include <cassert>
#include "SelectError.h"
#include "Evaluator.h"

using namespace SelectError;

#define NUM_OF(a)	(sizeof(a)/sizeof(a[0]))
int main()
{
	//	switch on exception handling
	selectErrorHandler.exceptions(true);

	const char *expr[] = { "1==1", "p==", "" };
	bool results[] = { true, false, true };

	for (unsigned n=0; n<NUM_OF(expr); ++n) {
		try {
			Evaluator ev(expr[n]);
			assert(results[n]);
		} catch (SelectException e) {
			assert(!results[n]);
			std::cerr<<e.text()<<endl;
		}

		assert(Evaluator::isValidExpression(expr[n]) == results[n]);
	}

	return 0;
}



