#include "SetTableColumn.h"

int main()
{
	//
	//	create temp data set
	//
	const std::string dsname = "composers.ds",
					  tabname = "MOZART",
					  colname = "MAGICFLUTE";

	DataSet *set = dataSetServer->open(dsname, Dal::Create);

	Table *tab = set->addTable(tabname, 0);
	tab->addColumn(colname, Dal::Bool);

	dataSetServer->close(set);

	std::vector<SetTableColumn *> v;
	v.push_back(new SetTableColumn(dsname));
	v.push_back(new SetTableColumn(dsname + ":"));
	v.push_back(new SetTableColumn(dsname + "+1"));
	v.push_back(new SetTableColumn(dsname + "+" + tabname));
	v.push_back(new SetTableColumn(dsname + "[1]"));
	v.push_back(new SetTableColumn(dsname + "[" + tabname + "]"));
	v.push_back(new SetTableColumn(dsname + ":1"));
	v.push_back(new SetTableColumn(dsname + ":" + tabname));
	v.push_back(new SetTableColumn(dsname + "::"));
	v.push_back(new SetTableColumn(dsname + "::0"));
	v.push_back(new SetTableColumn(dsname + "::" + colname));
	v.push_back(new SetTableColumn(dsname + ":" + tabname + ":" + colname));

	for (unsigned n=0; n<v.size(); ++n)
		assert(v[n]->dataSet()->name() == dsname &&
			   v[n]->table()->name() == tabname &&
			   v[n]->column()->name() == colname);

	SetTableColumn s(dsname + "::" + colname);

	assert(s.column()->name() == colname);

	return 0;
}
